USE [seralive]
GO
/****** Object:  View [dbo].[ACTUALCREDITORS]    Script Date: 03/25/2014 13:08:29 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO
CREATE VIEW [dbo].[ACTUALCREDITORS]
AS
SELECT 
CREDIT.CRINVOICE AS 'Invoice', 
CREDIT.CRDESCR AS 'Description', 
(0-CREDIT.CRAMOUNT/POWER(10,VALUTA.VADECIMALS)) AS 'Orginal amount', 
(0-CREDIT.CROPEN/POWER(10,VALUTA.VADECIMALS)) AS 'Outstanding', 
CREDIT.CRVALUTA AS 'Currency', 
VALUTA.VARATE AS 'Rate',
(0-CREDIT.CROPEN/POWER(10,VALUTA.VADECIMALS)*VALUTA.VARATE) AS 'Localamount', 
CONVERT(DATETIME,CREDIT.CRDATE,112) AS 'Posting date', 
CREDIT.CRNUMBER AS 'Journal', 
CREDIT.CRNUMBER2 AS 'Seqnr', 
CONVERT(DATETIME,CREDIT.CRPAYDATE,112) AS 'Pay date', 
SUPPL.SUNUMBER+' '+SUPPL.SUNAME AS 'Supplier',
CREDIT.CRACCO AS 'Account',
SUPPL.SUNAME AS 'Name',
SUPPL.SUCONTACT AS 'Contact',
SUPPL.SUPHONE AS 'Phone',
SUPPL.SUEMAIL AS 'Email'

FROM 
start.VALUTA VALUTA, 
start.SUPPL SUPPL, 
start.COMPANY COMPANY,
start.CREDIT CREDIT


WHERE 
CREDIT.CRSTATUS='1'
AND
CREDIT.CRVALUTA = VALUTA.VANUMBER 
AND 
CREDIT.CRCOMP=COMPANY.COBKCOMP
AND 
CREDIT.CRACCO=SUPPL.SUNUMBER 
GO


USE [seralive]
GO
/****** Object:  View [dbo].[ACTUALDEBTORS]    Script Date: 03/25/2014 13:09:01 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO
CREATE VIEW [dbo].[ACTUALDEBTORS]
AS
SELECT 
DEBTORS.DBINVOICE AS 'Invoice', 
DEBTORS.DBDESCR AS 'Description', 
(DEBTORS.DBAMOUNT/POWER(10,VALUTA.VADECIMALS)) AS 'Orginal amount', 
(DEBTORS.DBOPEN/POWER(10,VALUTA.VADECIMALS)) AS 'Outstanding', 
DEBTORS.DBVALUTA AS 'Currency', 
VALUTA.VARATE AS 'Rate',
(DEBTORS.DBOPEN/POWER(10,VALUTA.VADECIMALS)*VALUTA.VARATE) AS 'Localamount', 
CONVERT(DATETIME,DEBTORS.DBDATE,112) AS 'Posting date', 
DEBTORS.DBNUMBER AS 'Journal', 
DEBTORS.DBNUMBER2 AS 'Seqnr', 
INVHEAD.IVORDER AS 'Order',
INVHEAD.IVPACKLIST AS 'Packlist', 
INVHEAD.IVCUSTREF AS 'Customer reference',
INVHEAD.IVOWNREF AS 'Our reference',
INVHEAD.IVPAYTYPE AS 'Paytype',
CONVERT(DATETIME,DEBTORS.DBPAYDATE,112) AS 'Pay date', 
CUST.CUNUMBER+' '+CUST.CUNAME AS 'Customer',
DEBTORS.DBACCO AS 'Account',
CUST.CUNAME AS 'Name',
CUST.CUCONTACT AS 'Contact',
CUST.CUPHONE AS 'Phone',
CUST.CUEMAIL AS 'Email',
CUST.CUREP+' '+REP.REDESCR AS 'Area'

FROM 
start.VALUTA VALUTA, 
start.CUST CUST, 
start.REP REP,
start.COMPANY COMPANY,
start.DEBTORS DEBTORS
LEFT JOIN start.INVHEAD INVHEAD ON DEBTORS.DBINVOICE=INVHEAD.IVNUMBER

WHERE 
DEBTORS.DBSTATUS='1'
AND
DEBTORS.DBVALUTA = VALUTA.VANUMBER 
AND 
DEBTORS.DBCOMP=COMPANY.COBKCOMP
AND 
DEBTORS.DBACCO=CUST.CUNUMBER 
AND
CUST.CUREP=REP.RENUMBER
GO


USE [seralive]
GO
/****** Object:  View [dbo].[ACTUALSTOCK]    Script Date: 03/25/2014 13:09:17 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO

CREATE VIEW [dbo].[ACTUALSTOCK]
AS


SELECT 
STOCK.STPART+' '+PARTS.PADESCR AS 'Part', 
STOCK.STPART AS 'Partnumber',
STOCK.STLOT AS 'Lot number', 
STOCK.STWAREHOUS AS 'Warehouse', 
STOCK.STLOCATION AS 'Location', 
STOCK.STORGIQUAN AS 'Originalqnt', 
STOCK.STFREEQUAN AS 'Freeqnt', 
STOCK.STCOMMQUAN AS 'Committedqnt', 
STOCK.STQUALITY AS 'Quarantaineqnt',
STOCK.STFREEQUAN+STOCK.STCOMMQUAN+STOCK.STQUALITY AS 'Quantity', 
STOCK.STLOT2 AS 'Lotnr2', 
CONVERT(DATETIME,STOCK.STDATE,112) AS 'Date', 
CASE 
WHEN ISDATE(STOCK.STEXPIRE) = 1 
THEN 
 CONVERT(DATETIME,STOCK.STEXPIRE,112)
ELSE  
  CONVERT(DATETIME,'20991231',112)
END AS 'Expirydate', 
STOCK.STVAL AS 'Currency',
STOCK.STGRN AS 'Receiptnote', 
PARTS.PAGROUP + ' '+ PRTGROUP.PGDESCR as 'Partgroup',
PARTS.PATYPE AS 'Parttype', 
PARTS.PACOMPUNIT AS 'Unit', 
PARTS.PAMIN AS 'Minimumstock', 
PARTS.PAORDERQ AS 'Orderqnt', 
PARTS.PAORDERQEX AS 'Orderincrease', 
PARTS.PASAFETY AS 'Safetystock', 
PARTS.PALEADTIME AS 'Leadtime', 
PARTS.PASUPPPART AS 'Supplierpart', 
PARTS.PAWEIGHT AS 'Weight', 
PARTS.PAVOLUME AS 'Volume', 
PARTS.PAWAREHOUS AS 'Prefwarehouse', 
PARTS.PALOCATION AS 'Preflocation', 
PARTS.PAAUTORDER AS 'Autopurchase', 
PARTS.PASTAT AS 'Statisticcode', 
PARTS.PAPACKING AS 'Packing', 
PARTS.PATAXCODE AS 'Taxcode', 
SUPPL.SUNUMBER+' '+SUPPL.SUNAME AS 'Supplier', 
SUPPL.SUCOUNTRY AS 'Country', 
STOCK.STSOURCE AS 'Source',
STOCK.STPURPRICE/POWER(10,VALUTA.VADECIMALS) AS 'Purchaseprice',
STOCK.STHISTPRIC/POWER(10,VALUTA.VADECIMALS) AS 'Historicprice',
(STOCK.STFREEQUAN+STOCK.STCOMMQUAN+STOCK.STQUALITY)*(STOCK.STHISTPRIC/POWER(10,VALUTA.VADECIMALS)) AS 'Historicvalue',
(PARTS.PASTDCOST+STOCK.STSPECPRIC)/POWER(10,VALUTA.VADECIMALS) AS 'Standardprice',
(STOCK.STFREEQUAN+STOCK.STCOMMQUAN+STOCK.STQUALITY)*((PARTS.PASTDCOST+STOCK.STSPECPRIC)/POWER(10,VALUTA.VADECIMALS)) AS 'Standardvalue'


FROM 
start.PARTS PARTS, 
start.VALUTA VALUTA,
start.VALUHIST VALUHIST,
start.PRTGROUP PRTGROUP,
start.SUPPL SUPPL,
start.COMPANY COMPANY,
start.STOCK STOCK


WHERE 
STOCK.STPART=PARTS.PANUMBER AND 
STOCK.IS_DELETED='N' AND 
STOCK.STPART <> 'DELETED' AND
SUBSTRING(STOCK.STDATE,1,6)=VALUHIST.VHPERIOD AND STOCK.STVAL=VALUHIST.VHNUMBER AND 
PARTS.PAGROUP=PRTGROUP.PGNUMBER AND
STOCK.STSUPP=SUPPL.SUNUMBER AND
COMPANY.COVALUTA=VALUTA.VANUMBER
GO



USE [seralive]
GO
/****** Object:  View [dbo].[GENERALLEDGER]    Script Date: 03/25/2014 13:09:28 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO

CREATE VIEW [dbo].[GENERALLEDGER]
AS
SELECT     GENLEDG.GLACCO + ' ' + ACCOUNT.ACDESCR AS Account, GENLEDG.GLACCO AS Accountnr, SUBSTRING(CLAS.CLNUMBER, 5, 3) + ' ' + CLAS.CLDESCR AS MainGroup, SUBSTRING(ACCOUNT.ACNUMBER,5,10) AS AccountNumber,ACCOUNT.ACDESCR AS AccountName, SUBSTRING(CLAS.CLNUMBER,5,3) AS GroupNumber,CLAS.CLDESCR AS GroupName,
                      GENLEDG.GLNUMBER AS Journal, GENLEDG.GLNUMBER2 AS Seqnr, GENLEDG.GLPERIOD AS Period, GENLEDG.GLDEPART AS Department, 
                      GENLEDG.GLDESCR AS Description, GENLEDG.GLQUANT AS Quantity, GENLEDG.GLPROJECT AS Project, GENLEDG.GLUNIT AS Unit, 
                      GENLEDG.GLAMOUNT / POWER(10, VALUTA.VADECIMALS) AS CurrAmount, 
 CASE WHEN GENLEDG.GLAMOUNT > 0 THEN GENLEDG.GLAMOUNT / 100 ELSE 0 END AS CurrDebitAmount, 
                      CASE WHEN GENLEDG.GLAMOUNT < 0 THEN 0 - GENLEDG.GLAMOUNT / 100 ELSE 0 END AS CurrCreditAmount, GENLEDG.GLINVOICE AS InvoiceRef, CASE WHEN ISDATE(GENLEDG.GLDATE) 
                      = 1 THEN CONVERT(DATETIME, GENLEDG.GLDATE, 112) ELSE CASE WHEN ISDATE(GENLEDG.GLPERIOD + '01') = 1 THEN CONVERT(DATETIME, 
                      GENLEDG.GLPERIOD + '01', 112) ELSE CONVERT(DATETIME, '20150101', 112) END END AS Date, GENLEDG.GLVALUTA AS Currency, 
                      GENLEDG.GLSTATUS AS Status, GENLEDG.GLOPEN / POWER(10, VALUTA.VADECIMALS) AS Openamount, SUBSTRING(GENLEDG.GLPERIOD, 1, 4) 
                      AS Year
FROM         start.GENLEDG GENLEDG, 
                      start.ACCOUNT ACCOUNT, 
                      start.CLAS CLAS,
                      start.VALUTA VALUTA                      
WHERE     (GENLEDG.IS_DELETED = 'N') AND (GENLEDG.GLFIGUTYPE = '1') AND (GENLEDG.GLCOMP = '100' )
                  AND GENLEDG.GLVALUTA=VALUTA.VANUMBER
                  AND GENLEDG.GLACCO=SUBSTRING(ACCOUNT.ACNUMBER,5,10)
                  AND GENLEDG.GLCOMP = SUBSTRING(ACCOUNT.ACNUMBER,1,4)
                  AND ACCOUNT.ACCLASS = CLAS.CLNUMBER AND SUBSTRING(GENLEDG.GLPERIOD,1,4)>=YEAR(GETDATE()-750)


GO
USE [seralive]
GO
/****** Object:  View [dbo].[GOODSRECEIPTS]    Script Date: 03/25/2014 13:10:30 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[GOODSRECEIPTS]
AS
SELECT
MOVES.MOPART + ' ' + PARTS.PADESCR AS 'Part',
MOVES.MOPART AS 'Partnumber',
MOVES.MOQUANT AS 'Quantity', 
MOVES.MOAMOUNT/POWER(10,VALUTA.VADECIMALS) AS 'Price',
MOVES.MOQUANT*MOVES.MOAMOUNT/POWER(10,VALUTA.VADECIMALS) AS 'Value',
MOVES.MOREF AS 'Receipt note', 
CONVERT(DATETIME,MOVES.MODATE,112) AS 'Date',
MOVES.MOTIME AS 'Time ', 
SUBSTRING(MOVES.MODATE,1,6) AS 'Month',
SUBSTRING(MOVES.MODATE,1,4) AS 'Year',
MOVES.MOWAREHOUS AS 'Warehouse', 
MOVES.MOLOCATION AS 'Location',
MOVES.MOLOT AS 'Lot nr',
MOVES.MOLOT2 AS 'Lot nr 2',  
MOVES.MOINVOICE AS 'Invoice', 
MOVES.MOSTOCKP AS 'Stock part', 
MOVES.MODEPART AS 'Department',  
MOVES.MOSTOACCO AS 'Receipt account', 
PARTS.PAGROUP + '  '+ PRTGROUP.PGDESCR AS 'PartGroup', 
SUPPL.SUNUMBER + ' '+SUPPL.SUNAME AS 'Supplier',
SUPPL.SUCOUNTRY AS 'Supplier country', 
CASE 
WHEN ISDATE(MOVES.MOREQDATE) = 1 
THEN 
 CONVERT(DATETIME,MOVES.MOREQDATE,112)
ELSE  
 CONVERT(DATETIME,MOVES.MODATE,112)
END
AS 'Reqdate',
CASE 
WHEN ISDATE(MOVES.MOREQDATE) = 1 
THEN 
 DATEDIFF(day,CONVERT(DATETIME,MOVES.MOREQDATE,112),CONVERT(DATETIME,MOVES.MODATE,112))
ELSE  
 0
END
AS 'Toolate' 



FROM 
start.PARTS PARTS, 
start.PRTGROUP PRTGROUP,
start.MOVES MOVES,
start.GOODS GOODS,
start.SUPPL SUPPL,
start.COMPANY COMPANY,
start.VALUTA VALUTA


WHERE
MOVES.IS_DELETED='N'
AND 
MOVES.MOPART=PARTS.PANUMBER
AND
PARTS.PAGROUP=PRTGROUP.PGNUMBER
AND
MOVES.MOTYPE='P'
AND
MOVES.MOREF=GOODS.GONUMBER
AND
GOODS.GOSUPPL=SUPPL.SUNUMBER
AND 
COMPANY.COVALUTA=VALUTA.VANUMBER
AND
SUBSTRING(MODATE,1,4) >= YEAR(GETDATE()-750)


GO

USE [seralive]
GO
/****** Object:  View [dbo].[HISTORICCREDITORS]    Script Date: 03/25/2014 13:52:35 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[HISTORICCREDITORS]
AS
SELECT
CREDIT.CRNUMBER AS Journal,
CREDIT.CRNUMBER2 AS Seq,
CREDIT.CRDESCR AS Description,
CONVERT(DATETIME,CRDATE,112) AS Postingdate,
CREDIT.CRSTATUS AS Status,
CASE
WHEN CREDIT.CRSTATUS='3'
THEN 0
ELSE
0-CREDIT.CROPEN / POWER(10,VALUTA.VADECIMALS) END 
AS Outstanding,
CREDIT.CRINVOICE AS Invoice, 
CREDIT.CRVALUTA AS Currency,
0-CREDIT.CRAMOUNT / POWER(10, VALUTA.VADECIMALS) AS Amount,
SUPPL.SUNUMBER + ' ' + SUPPL.SUNAME AS Supplier,
CREDIT.CRACCO AS Account,
SUPPL.SUNAME AS Name,
CASE 
WHEN CREDIT.CRINVOICE=BUY.BUINVOICE THEN CONVERT(DATETIME,BUDATE,112) 
ELSE 
CONVERT(DATETIME,CRINVOICE,112)
END
AS Invoicedate,
CREDIT.CRPERIOD AS Period 

FROM         
start.VALUTA VALUTA,
start.SUPPL SUPPL,
start.COMPANY COMPANY,
start.CREDIT CREDIT

LEFT JOIN start.BUY BUY ON CREDIT.CRINVOICE=BUY.BUINVOICE

WHERE
VALUTA.VANUMBER = CREDIT.CRVALUTA AND
CREDIT.CRCOMP = COMPANY.COBKCOMP AND
BUY.BUCOMP = COMPANY.COBKCOMP AND 
CREDIT.CRACCO = SUPPL.SUNUMBER AND 
(SUBSTRING(BUY.BUDATE,1,4) >= YEAR(GETDATE()-750) OR CREDIT.CRINVOICE<>BUY.BUINVOICE)
GO


USE [seralive]
GO
/****** Object:  View [dbo].[HISTORICDEBTORS]    Script Date: 03/25/2014 13:52:59 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[HISTORICDEBTORS]
AS
SELECT
DEBTORS.DBNUMBER AS Journal,
DEBTORS.DBNUMBER2 AS Seq,
DEBTORS.DBDESCR AS Description,
CONVERT(DATETIME,DBDATE,112) AS Postingdate,
DEBTORS.DBSTATUS AS Status,
CASE
WHEN DEBTORS.DBSTATUS='3'
THEN 0
ELSE
DEBTORS.DBOPEN / POWER(10,VALUTA.VADECIMALS) END 
AS Outstanding,
DEBTORS.DBINVOICE AS Invoice, 
DEBTORS.DBVALUTA AS Currency,
DEBTORS.DBAMOUNT / POWER(10, VALUTA.VADECIMALS) AS Amount,
CUST.CUNUMBER + ' ' + CUST.CUNAME AS Customer,
DEBTORS.DBACCO AS Account,
CUST.CUNAME AS Name,
CASE 
WHEN DEBTORS.DBINVOICE=INVHEAD.IVNUMBER THEN CONVERT(DATETIME,IVDATE,112) 
ELSE 
CONVERT(DATETIME,DBINVOICE,112)
END
AS Invoicedate,
DEBTORS.DBPERIOD AS Period 

FROM         
start.VALUTA VALUTA,
start.CUST CUST,
start.COMPANY COMPANY,
start.DEBTORS DEBTORS

LEFT JOIN start.INVHEAD INVHEAD ON DEBTORS.DBINVOICE=INVHEAD.IVNUMBER

WHERE
VALUTA.VANUMBER = DEBTORS.DBVALUTA AND
DEBTORS.DBCOMP = COMPANY.COBKCOMP AND
DEBTORS.DBACCO = CUST.CUNUMBER AND 
(SUBSTRING(IVDATE,1,4) >= YEAR(GETDATE()-750) OR DEBTORS.DBINVOICE<>INVHEAD.IVNUMBER)
GO


USE [seralive]
GO
/****** Object:  View [dbo].[HISTORICSTOCK]    Script Date: 03/25/2014 13:53:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE VIEW [dbo].[HISTORICSTOCK]
AS
SELECT
MOVES.MOPART+' ' + PARTS.PADESCR AS 'Part',
MOVES.MOPART AS 'Partnumber',
0-MOVES.MOQUANT AS 'Quantity',
CONVERT(DATETIME,MOVES.MODATE,112) AS 'Date',
SUBSTRING(MOVES.MODATE,1,6) AS 'Month',
SUBSTRING(MOVES.MODATE,1,4) AS 'Year',
MOVES.MOWAREHOUS AS 'Warehouse', 
MOVES.MOLOCATION AS 'Location',
MOVES.MOLOT AS 'Lot nr',
PARTS.PAGROUP +' '+PRTGROUP.PGDESCR AS 'PartGroup', 
MOVES.MOAMOUNT/POWER(10,VALUTA.VADECIMALS)*(0-MOVES.MOQUANT) AS 'HistoricValue',
MOVES.MOAMOUNT/POWER(10,VALUTA.VADECIMALS)*(0-MOVES.MOQUANT) AS 'StandardValue'


FROM 
start.PARTS PARTS, 
start.PRTGROUP PRTGROUP,
start.COMPANY COMPANY,
start.VALUTA VALUTA,
start.MOVES MOVES

WHERE
MOVES.IS_DELETED='N'
AND 
MOVES.MOPART=PARTS.PANUMBER
AND
PARTS.PAGROUP=PRTGROUP.PGNUMBER
AND 
MOVES.MOSTOCKP<>'N'
AND
SUBSTRING(MOVES.MODATE,1,4)>=YEAR(GETDATE()-750)
AND 
COMPANY.COVALUTA = VALUTA.VANUMBER 

UNION ALL

SELECT
STOCK.STPART+' '+PARTS.PADESCR AS 'Part',
STOCK.STPART AS 'Partnumber',
STOCK.STFREEQUAN+STOCK.STQUALITY+STOCK.STCOMMQUAN AS 'Quantity',
'20291231' AS 'Date',
'202912'AS 'Month',
'2029' AS 'Year',
STOCK.STWAREHOUS AS 'Warehouse', 
STOCK.STLOCATION AS 'Location',
STOCK.STLOT AS 'Lot nr',
PARTS.PAGROUP+' '+PRTGROUP.PGDESCR AS 'PartGroup', 
(STOCK.STFREEQUAN+STOCK.STQUALITY+STOCK.STCOMMQUAN)*(STHISTPRIC/POWER(10,VALUTA.VADECIMALS)) AS 'HistoricValue',
(STOCK.STFREEQUAN+STOCK.STQUALITY+STOCK.STCOMMQUAN)*((PARTS.PASTDCOST/POWER(10,VALUTA.VADECIMALS))+(STOCK.STSPECPRIC/POWER(10,VALUTA.VADECIMALS))) AS 'StandardValue'


FROM 
start.PARTS PARTS, 
start.PRTGROUP PRTGROUP,
start.COMPANY COMPANY,
start.VALUTA VALUTA,
start.STOCK STOCK

WHERE
STOCK.IS_DELETED='N'
AND
STOCK.STPART <> 'DELETED'
AND 
STOCK.STPART=PARTS.PANUMBER
AND
PARTS.PAGROUP=PRTGROUP.PGNUMBER
AND 
COMPANY.COVALUTA = VALUTA.VANUMBER
GO


USE [seralive]
GO
/****** Object:  View [dbo].[PURCHASEINVOICES]    Script Date: 03/25/2014 13:54:04 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO

CREATE VIEW [dbo].[PURCHASEINVOICES]
AS

SELECT
BUYLINE.BLINVOICE AS 'Invoice',
BUYLINE.BLDESCR     AS 'Description',
BUYLINE.BLPROJECT   AS 'Project',
BUYLINE.BLREF       AS 'Reference',
BUYLINE.BLACCO      AS 'Account',
ACCOUNT.ACDESCR     AS 'Account name',
BUYLINE.BLDEPART    AS 'Department',
PARTS.PANUMBER AS 'Part',
PARTS.PADESCR AS 'Part description',
SUPPL.SUNUMBER AS 'Supplier', 
SUPPL.SUNAME AS 'Supplier name', 
SUPPL.SUCOUNTRY as 'Country', 
SUPPL.SUVAL AS 'Currency',
VALUTA.VADECIMALS AS 'D',
BUY.BUPERIOD AS 'Period',
PARTS.PACOMPUNIT,
BUYLINE.BLPERI1     AS 'Period 1',
BUYLINE.BLPERI2     AS 'Period 2',
BUYLINE.BLPERI3     AS 'Period 3',
BUYLINE.BLPERI4     AS 'Period 4',
BUYLINE.BLPERI5     AS 'Period 5',
BUYLINE.BLPERI6     AS 'Period 6',
BUYLINE.BLPERI7     AS 'Period 7',
BUYLINE.BLPERI8     AS 'Period 8',
BUYLINE.BLPERI9     AS 'Period 9',
BUYLINE.BLPERI10    AS 'Period 10',
BUYLINE.BLPERI11    AS 'Period 11',
BUYLINE.BLPERI12    AS 'Period 12',
BUYLINE.BLPERI13    AS 'Period 14',
BUYLINE.BLAMOUNT,
BUYLINE.BLPURCHASE,
BUYLINE.BLPRICDIFF,
BUYLINE.BLAMOUNT1,   
BUYLINE.BLAMOUNT2,   
BUYLINE.BLAMOUNT3,   
BUYLINE.BLAMOUNT4,   
BUYLINE.BLAMOUNT5,   
BUYLINE.BLAMOUNT6,   
BUYLINE.BLAMOUNT7,   
BUYLINE.BLAMOUNT8,   
BUYLINE.BLAMOUNT9,   
BUYLINE.BLAMOUNT10,  
BUYLINE.BLAMOUNT11,  
BUYLINE.BLAMOUNT12,  
BUYLINE.BLAMOUNT13,
BUYLINE.BLQUANT,
BUYLINE.BLUNIT,
GOODSHLP.GHQUANT,
GOODSHLP.GHAMOUNTIN,
GOODSHLP.GHVALUTAIN,
GOODSHLP.GHAMOUNTPU,
GOODSHLP.GHVALUTAPU,
SUBSTRING(BUY.BUPERIOD,1,4) AS 'Year',
CONVERT(DATETIME,BUY.BUDATE,112) AS 'Date', 
CONVERT(DATETIME,BUY.BUPAYDATE,112) AS 'Pay date', 
BUYLINE.BLVTAMOUNT

FROM
start.ACCOUNT ACCOUNT,
start.BUY BUY,
start.COMPANY COMPANY,
start.SUPPL SUPPL,
start.VALUTA VALUTA,
start.VALUHIST VALUHIST,
start.BUYLINE BUYLINE

LEFT JOIN 
start.GOODSHLP GOODSHLP
ON  
BUYLINE.BLINVOICE=GOODSHLP.GHINVOICE
AND 
BUYLINE.BLSEQ=GOODSHLP.GHLINE

LEFT JOIN start.PARTS PARTS 
ON
PARTS.PANUMBER=GOODSHLP.GHPART

WHERE
BUYLINE.BLACCO=SUBSTRING(ACNUMBER,5,10)
AND
BUYLINE.BLCOMP=SUBSTRING(ACNUMBER,1,4)
AND
BUYLINE.BLINVOICE=BUY.BUINVOICE
AND
BUYLINE.BLCOMP=BUY.BUCOMP
AND
SUBSTRING(BUY.BUPERIOD,1,4)>=YEAR(GETDATE()-750)
AND
BUY.BUCOMP=COMPANY.COBKCOMP
AND
BUY.BUSUPPL=SUPPL.SUNUMBER
AND
BUY.BUVALUTA=VALUHIST.VHNUMBER
AND
BUY.BUPERIOD=VALUHIST.VHPERIOD
AND
VALUTA.VANUMBER=COMPANY.COVALUTA
GO

USE [seralive]
GO
/****** Object:  View [dbo].[PURCHASEINVOICEHEADERS]    Script Date: 03/25/2014 13:53:36 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO

CREATE VIEW [dbo].[PURCHASEINVOICEHEADERS]
AS

SELECT
BUY.BUINVOICE AS 'Invoice',
BUY.BUDESCR   AS 'Description',
BUY.BUPERIOD  AS 'Period',
BUY.BUSUPPL   AS 'Supplier',
SUPPL.SUNAME AS 'Supplier name', 
SUPPL.SUCOUNTRY as 'Country', 
SUPPL.SUVATNR AS 'VATnumber',
BUY.BUAMOUNT/POWER(10,VALUTA.VADECIMALS) AS 'Currencyamount',
BUY.BUVALUTA AS 'Currency',
BUY.BUVAT/POWER(10,VALUTA.VADECIMALS) AS 'VATamount',
CONVERT(DATETIME,BUY.BUDATE,112) AS 'Date', 
CONVERT(DATETIME,BUY.BUPAYDATE,112)  AS 'Pay date', 
SUBSTRING(BUPERIOD,1,4) AS 'Year',
BUY.BUAPPROV AS 'Approved'


FROM
start.BUY BUY,
start.SUPPL SUPPL,
start.VALUTA VALUTA,
start.COMPANY COMPANY


WHERE
SUBSTRING(BUY.BUPERIOD,1,4)<=YEAR(GETDATE()-750)
AND
BUY.BUCOMP=COMPANY.COBKCOMP
AND
BUY.BUSUPPL=SUPPL.SUNUMBER
AND
BUY.BUVALUTA=VALUTA.VANUMBER
GO 

USE [seralive]
GO
/****** Object:  View [dbo].[SALESINVOICES]    Script Date: 04/07/2014 07:26:50 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO

CREATE VIEW 	[dbo].[SALESINVOICES]
AS

SELECT 
INVLINE.ILNUMBER AS Invoice, 
CONVERT(DATETIME,INVHEAD.IVDATE,112) AS InvoiceDate, 
INVLINE.ILQUANT AS Quantity, 
INVLINE.ILUNIT AS Unit,
INVLINE.ILDESCR AS Description,
INVLINE.ILNETT AS NettpriceMark, 
INVLINE.ILDISCOUNT/100 AS Discount,
INVHEAD.IVVAL AS Currency,
INVLINE.ILRETAIL / POWER(10,VALUTA.VADECIMALS) AS RetailUnitPrice,
INVLINE.ILVALUTA / POWER(10,VALUHIST.VHDECIMALS) AS CurrencyUnitPrice,
INVLINE.ILVAT / POWER(10,VALUHIST.VHDECIMALS) AS VatAmount,
INVLINE.ILCOSTPRIC / POWER(10,VALUTA.VADECIMALS) AS StatisticCostprice,
INVLINE.ILSTDCOST / POWER(10,VALUTA.VADECIMALS) AS StockUnitCosts,
INVLINE.ILAMOUNT / POWER(10,VALUTA.VADECIMALS) AS UnitPrice,
INVLINE.ILQUANT * INVLINE.ILAMOUNT / POWER(10,VALUTA.VADECIMALS) AS SalesAmount, 
INVLINE.ILQUANT * INVLINE.ILSTDCOST / POWER(10,VALUTA.VADECIMALS) AS StockCosts, 
0-(INVLINE.ILQUANT * INVLINE.ILSTDCOST / POWER(10,VALUTA.VADECIMALS)) AS StockPosting,
((INVLINE.ILQUANT * INVLINE.ILVALUTA)+INVLINE.ILVAT) / POWER(10,VALUHIST.VHDECIMALS) AS DebtorsPosting,
CASE 
WHEN VALUTA.VANUMBER<>VALUHIST.VHNUMBER THEN INVLINE.ILQUANT * INVLINE.ILVALUTA / POWER(10,VALUHIST.VHDECIMALS)ELSE 0
END
AS CurrencyPositionPosting,
CASE 
WHEN VALUTA.VANUMBER<>VALUHIST.VHNUMBER THEN INVLINE.ILQUANT * INVLINE.ILAMOUNT / POWER(10,VALUTA.VADECIMALS)ELSE 0
END
AS LocalPositionPosting,
INVLINE.ILQUANT * (INVLINE.ILAMOUNT-INVLINE.ILSTDCOST) / POWER(10,VALUTA.VADECIMALS) AS StockMargin, 
INVLINE.ILQUANT * INVLINE.ILCOSTPRIC / POWER(10,VALUTA.VADECIMALS) AS StatisticCosts, 
INVLINE.ILQUANT * (INVLINE.ILAMOUNT-INVLINE.ILCOSTPRIC) / POWER(10,VALUTA.VADECIMALS) AS StatisticMargin, 
CUST.CUNUMBER + ' '+CUST.CUNAME AS Customer,
CUST.CUNUMBER AS CustomerNumber,
CUST.CUNAME AS CustomerName,
CUST.CUCOUNTRY AS CustomerCountry, 
CUST.CUHEAD AS HeadOffice, 
CUST.CUVATNR AS VatNumber, 
INVHEAD.IVADRESS2 AS DeliveryCity,
INVHEAD.IVCOUNTRY AS DeliveryCountry, 
INVHEAD.IVORIGIN AS OriginCountry,
REP.RENUMBER+' '+REP.REDESCR AS Area,
REP.RENUMBER AS AreaNumber, 
REP.REDESCR AS AreaName,
INVHEAD.IVORDER AS OrderNumber,
SUBSTRING(INVHEAD.IVDATE,1,6) AS Month,
SUBSTRING(INVHEAD.IVDATE,1,4) AS Year,
INVHEAD.IVDELTERMS AS DeliveryTerms, 
INVHEAD.IVPAYTYPE AS PayType, 
INVHEAD.IVPAYTERMS AS PayTerms, 
INVHEAD.IVPACKLIST AS PickingList, 
INVHEAD.IVORIGIN AS Origin, 
INVHEAD.IVTRANSP AS Transporter, 
PARTS.PANUMBER+' '+PARTS.PADESCR AS Part, 
PARTS.PANUMBER AS PartNumber,
PARTS.PADESCR AS PartName,
PARTS.PASUPP AS PreferredSupplier, 
PARTS.PASUPPPART AS SupplierPart,
PARTS.PAWEIGHT AS Weight, 
PARTS.PAVOLUME AS Volume,
PARTS.PATAXCODE AS HScode,
PRTGROUP.PGNUMBER + ' '+PRTGROUP.PGDESCR AS PartGroup,
PRTGROUP.PGNUMBER AS PartGroupNumber,
PRTGROUP.PGDESCR AS PartGroupName,
INVLINE.ILTOACCO + ' '+ACCOUNT.ACDESCR AS SalesAccount, 
INVLINE.ILTOACCO AS SalesAccountNumber,
ACCOUNT.ACDESCR AS SalesAccountName,
INVHEAD.IVSEQNR AS CollectSeq,
INVLINE.ILPUACCO AS StockAccountNumber,
INVLINE.ILCOACCO AS CostOfSalesAccountNumber,
INVLINE.ILVATACCO AS VatAccountNumber,
INVLINE.ILVATCODE AS VatCode,
PARTEXT.PX1 AS Userfield1,
PARTEXT.PX2 AS Userfield2,
PARTEXT.PX3 AS Userfield3,
PARTEXT.PX4 AS Userfield4,
PARTEXT.PX5 AS Userfield5,
PARTEXT.PX6 AS Userfield6,
PARTEXT.PX7 AS Userfield7,
PARTEXT.PX8 AS Userfield8,
PARTEXT.PX9 AS Userfield9,
PARTEXT.PX10 AS Userfield10

FROM
start.INVLINE INVLINE,
start.ACCOUNT ACCOUNT,
start.CUST CUST, 
start.INVHEAD INVHEAD, 
start.PRTGROUP PRTGROUP, 
start.REP REP,
start.VALUTA VALUTA,
start.VALUHIST VALUHIST,
start.COMPANY COMPANY,
start.PARTS PARTS

LEFT JOIN 
start.PARTEXT PARTEXT
ON  
PARTS.PANUMBER=PARTEXT.PXNUMBER 

WHERE
INVLINE.ILNUMBER=INVHEAD.IVNUMBER
AND 
INVLINE.ILINVSEQ=INVHEAD.IVSEQNR
AND
INVLINE.ILPART=PARTS.PANUMBER
AND
PARTS.PAGROUP=PRTGROUP.PGNUMBER
AND
INVLINE.ILTOACCO=SUBSTRING(ACCOUNT.ACNUMBER,5,10)
AND 
COMPANY.COBKCOMP = SUBSTRING(ACCOUNT.ACNUMBER,1,4)
AND
CUST.CUNUMBER=SUBSTRING(INVHEAD.IVCUST,2,10)
AND
INVHEAD.IVVAL=VALUTA.VANUMBER
AND
CUST.CUREP=REP.RENUMBER
AND
INVLINE.ILQUANT<> 0
AND
SUBSTRING(INVHEAD.IVDATE,1,6) = VALUHIST.VHPERIOD
AND 
INVHEAD.IVVAL = VALUHIST.VHNUMBER 
AND 
COMPANY.COVALUTA = VALUTA.VANUMBER AND SUBSTRING(INVHEAD.IVDATE,1,4)>=YEAR(GETDATE()-750)
GO


USE [seralive]
GO
/****** Object:  View [dbo].[SALESINVOICESHEADERS]    Script Date: 03/25/2014 13:54:37 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO

CREATE VIEW 	[dbo].[SALESINVOICEHEADERS]
AS

SELECT 
INVHEAD.IVNUMBER AS Invoice, 
CONVERT(DATETIME,INVHEAD.IVDATE,112) AS InvoiceDate, 
INVHEAD.IVSALES / POWER(10,VALUTA.VADECIMALS) AS Localamount,
INVHEAD.IVVALUTA / POWER(10,VALUHIST.VHDECIMALS) AS SalesAmount,
INVHEAD.IVVAT / POWER(10,VALUHIST.VHDECIMALS) AS VATAmount,
(INVHEAD.IVVALUTA+INVHEAD.IVVAT) / POWER(10,VALUHIST.VHDECIMALS) AS TotalAmount,
CUST.CUNUMBER + ' '+CUST.CUNAME AS Customer,
CUST.CUNUMBER AS CustomerNumber,
CUST.CUNAME AS CustomerName,
CUST.CUCOUNTRY AS CustomerCountry, 
CUST.CUHEAD AS HeadOffice, 
CUST.CUVATNR AS VatNumber, 
INVHEAD.IVADRESS2 AS DeliveryCity,
INVHEAD.IVCOUNTRY AS DeliveryCountry, 
INVHEAD.IVORIGIN AS OriginCountry,
REP.RENUMBER+' '+REP.REDESCR AS Area,
REP.RENUMBER AS AreaNumber, 
REP.REDESCR AS AreaName,
INVHEAD.IVORDER AS OrderNumber,
SUBSTRING(INVHEAD.IVDATE,1,6) AS Month,
SUBSTRING(INVHEAD.IVDATE,1,4) AS Year,
INVHEAD.IVDELTERMS AS DeliveryTerms, 
INVHEAD.IVPAYTYPE AS PayType, 
INVHEAD.IVPAYTERMS AS PayTerms, 
INVHEAD.IVPACKLIST AS PickingList, 
INVHEAD.IVORIGIN AS Origin, 
INVHEAD.IVTRANSP AS Transporter,
INVHEAD.IVCUSTREF AS Customerreference,
INVHEAD.IVOWNREF AS Ownrefence



FROM
start.CUST CUST, 
start.INVHEAD INVHEAD, 
start.REP REP,
start.VALUTA VALUTA,
start.VALUHIST VALUHIST,
start.COMPANY COMPANY

WHERE
CUST.CUNUMBER=SUBSTRING(INVHEAD.IVCUST,2,10)
AND
INVHEAD.IVVAL=VALUTA.VANUMBER
AND
CUST.CUREP=REP.RENUMBER
AND
SUBSTRING(INVHEAD.IVDATE,1,6) = VALUHIST.VHPERIOD
AND 
INVHEAD.IVVAL = VALUHIST.VHNUMBER 
AND 
COMPANY.COVALUTA = VALUTA.VANUMBER AND SUBSTRING(INVHEAD.IVDATE,1,4)>=YEAR(GETDATE()-750)
GO


USE [seralive]
GO
/****** Object:  View [dbo].[STOCKMOVEMENTS]    Script Date: 03/25/2014 13:54:53 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO

CREATE VIEW [dbo].[STOCKMOVEMENTS]
AS

SELECT
MOVES.MOPART + ' ' + PARTS.PADESCR AS 'Part',
MOVES.MOPART AS 'Partnumber', 
MOVES.MOQUANT AS 'Quantity', 
MOVES.MOREF AS 'Reference', 
CONVERT(DATETIME,MOVES.MODATE,112) AS 'Date',
MOVES.MOTIME AS 'Time ', 
SUBSTRING(MOVES.MODATE,1,6) AS 'Month',
SUBSTRING(MOVES.MODATE,1,4) AS 'Year',
MOVES.MOWAREHOUS AS 'Warehouse', 
MOVES.MOLOCATION AS 'Location',
MOVES.MOLOT AS 'Lot nr',
MOVES.MOLOT2 AS 'Lot nr 2',  
MOVES.MOINVOICE AS 'Invoice', 
MOVES.MOSTOCKP AS 'Stock part', 
MOVES.MODEPART AS 'Department',  
MOVES.MOSTOACCO AS 'Stock account', 
MOVES.MOUSEACCO + ' '+ ACCOUNT.ACDESCR AS 'Contra account', 
SUBSTRING(INVHEAD.IVCUST,2,10) + ' '+ INVHEAD.IVNAME as 'Customer',
INVHEAD.IVORDER as 'Sales order',
INVHEAD.IVCUSTREF as 'Customer reference', 
INVHEAD.IVOWNREF as 'Own reference',
INVHEAD.IVPACKLIST as 'Picking list',
SUPPL.SUNUMBER+' '+SUPPL.SUNAME AS 'Supplier', 
PARTS.PAGROUP + ' ' + PRTGROUP.PGDESCR AS 'Part group', 
MOVES.MOAMOUNT/POWER(10,VALUTA.VADECIMALS) AS 'Price',
MOVES.MOQUANT*MOVES.MOAMOUNT/POWER(10,VALUTA.VADECIMALS) AS 'Value',
0-MOVES.MOQUANT*MOVES.MOAMOUNT/POWER(10,VALUTA.VADECIMALS) AS 'Contraposting',
CASE
WHEN MOTYPE = 'X' THEN 'Produced             '
WHEN MOTYPE = 'S' THEN 'Sold                 '
WHEN MOTYPE = 'W' THEN 'Used in production   '
WHEN MOTYPE = 'P' THEN 'Goods receipt        '
WHEN MOTYPE = 'I' THEN 'Manual adjustment in '
WHEN MOTYPE = 'O' THEN 'Manual adjustment out'
WHEN MOTYPE = 'M' THEN 'Stock movement       '
WHEN MOTYPE = 'R' THEN 'Used in repair       '
WHEN MOTYPE = 'B' THEN 'Purchase in repair   '
WHEN MOTYPE = 'C' THEN 'Price change         '
WHEN MOTYPE = 'E' THEN 'Used in maintenance  '
WHEN MOTYPE = 'H' THEN 'Rented to projects   '
WHEN MOTYPE = 'G' THEN 'Rented to repairs    '
WHEN MOTYPE = 'Q' THEN 'Storage              '
ELSE 'Others               '
END AS 'Mutation type'


FROM 
start.PARTS PARTS, 
start.PRTGROUP PRTGROUP,
start.ACCOUNT ACCOUNT, 
start.COMPANY COMPANY,
start.VALUTA VALUTA,
start.MOVES MOVES

LEFT JOIN start.INVHEAD INVHEAD ON MOVES.MOINVOICE=INVHEAD.IVNUMBER AND MOVES.MOTYPE = 'S'
LEFT JOIN start.GOODS GOODS ON MOVES.MOREF=GOODS.GONUMBER AND MOVES.MOTYPE = 'P'
LEFT JOIN start.SUPPL SUPPL ON GOODS.GOSUPPL=SUPPL.SUNUMBER AND MOVES.MOTYPE = 'P'

WHERE

MOVES.IS_DELETED='N'
AND
MOVES.MOUSEACCO=SUBSTRING(ACCOUNT.ACNUMBER,5,10)
AND SUBSTRING(ACCOUNT.ACNUMBER,1,4)=COMPANY.COBKCOMP 
AND 
MOVES.MOPART=PARTS.PANUMBER
AND
PARTS.PAGROUP=PRTGROUP.PGNUMBER
AND
COMPANY.COVALUTA=VALUTA.VANUMBER
AND 
MOVES.MOSTOCKP <> 'N'
AND 
SUBSTRING(MODATE,1,4) >= YEAR(GETDATE()-750)

GO 
